#ifndef ASPECT_STRUCT_H
#define ASPECT_STRUCT_H

#define ASPECT_MAX_ASPECT_MAP_SIZE  100  /* SICK_MAX_ACQ_SEGS */
#define ASPECT_MAX_INPUT_MAP_SIZE  1000  /* for poster size */

typedef enum ASPECT_BOOL {
  ASPECT_TRUE = 1,
  ASPECT_FALSE = 0
} ASPECT_BOOL;

typedef struct ASPECT_POLAR_SEG {
  double r1, t1;
  double r2, t2;
} ASPECT_POLAR_SEG;

typedef struct ASPECT_SEG {
  double x1, y1;
  double x2, y2;
} ASPECT_SEG;

typedef struct ASPECT_POLAR_SEGS {
  ASPECT_POLAR_SEG segs[ASPECT_MAX_ASPECT_MAP_SIZE];
} ASPECT_POLAR_SEGS;

typedef enum ASPECT_SEG_TYPE {
  ASPECT_MAP_SEG,
  ASPECT_LASER_SEG
} ASPECT_SEG_TYPE;

typedef struct ASPECT_SEGS_TYPE {
  ASPECT_SEG_TYPE segType[ASPECT_MAX_ASPECT_MAP_SIZE];
} ASPECT_SEGS_TYPE;

typedef struct ASPECT_CONFIG {
  double x, y, theta;
} ASPECT_CONFIG;

typedef struct ASPECT_VIEW_PARAMETERS {
  int keepReversedSegs;  /* 1 to keep reversed segs in the final aspect map */
  int unused;
  double maxDistView;    /* visibility distance in meters */
  double halfAngleView;  /* the scan is [-halfAngleView,halfAngleView]. 
			    (one can put 0 instead of 2*PI) */
  double minAspectSegAngle; /* minimum angle within a seg is view (to filter far 
			       little segs) */
} ASPECT_VIEW_PARAMETERS;

#define ASPECT_STRING_LENGTH 64
typedef struct ASPECT_STRING {
  char name[ASPECT_STRING_LENGTH];
} ASPECT_STRING;

typedef struct ASPECT_EXPORT_LASER {
  ASPECT_BOOL simulData;
  ASPECT_BOOL fuseRealData;
  double thMinDeg, thMaxDeg, dThDeg;
} ASPECT_EXPORT_LASER;


#endif
